/*
 * Copyright (c) 2002, Regents of the University of California. All rights reserved.
 * 
 * ===================================================================
 * The Apache Software License, Version 1.1
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The end-user documentation included with the redistribution, if
 *    any, must include the following acknowledgment:
 *       "This product includes software developed by
 *        the Institute for Software Research at  
 *        University of California, Irvine"
 *    Alternately, this acknowledgment may appear in the software
 *    itself, if and wherever such third-party acknowledgments normally
 *    appear.
 * 
 * 4. The names "YANCEES", "Institute for Software Research" and
 *    "University of California" must not be used to
 *    endorse or promote products derived from this software without
 *    prior written permission. For written permission, please contact
 *    rsilvafi@ics.uci.edu or redmiles@ics.uci.edu.
 * 
 * 5. Products derived from this software may not be called
 *    "YANCEES", nor may "YANCEES" appear in their name, without
 *    prior written permission of the University of California Regents.
 * 
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL WEBCOLLAB.COM OR ITS CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * ====================================================================
 */
 package test;

/**
 * <p>Title: Yancees Notification Server</p>
 * <p>Description: Yet ANother Configurable Extensible Event Service</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: School of Information and Computer Science - University of California, Irvine</p>
 * @author Roberto Silveira Silva Filho
 * @version 1.0
 */

import edu.uci.isr.yancees.util.DOMNodeAdapter;

public class NotificationManagerTest {


   public NotificationManagerTest() {
   }

   public static void main(String[] args) {

      /*
      if (args.length != 1) {
         System.err.println("Usage: NotificationManagerTest <filename>");
         System.exit(1);

      }


      PluginManager notificationPluginManager;
      PluginManager subscriptionPluginManager;
      NotificationManager notificationManager;
      SubscriptionManager subscriptionManager;


      notificationManager = NotificationManager.getInstance();
      subscriptionManager = SubscriptionManager.getInstance();

      notificationPluginManager = new PluginManager();
      subscriptionPluginManager = new PluginManager();


      // Configure the plugin manager instance used by the SubscriptionManager...
      subscriptionPluginManager.addFactory(new yancees.server.plugins.subscription.
                                           SubscriptionPluginFactory());
      subscriptionPluginManager.addFactory(new yancees.core.siena.
                                           SienaPluginFactory());
      subscriptionPluginManager.addFactory(new yancees.server.plugins.subscription.
                                           sequence.
                                           SequencePluginFactory());
      subscriptionPluginManager.addFactory(new yancees.server.plugins.subscription.rule.
                                           RulePluginFactory());
      subscriptionPluginManager.addFactory(new yancees.server.plugins.generic.
                                           GenericPluginFactory());

      // Configure subscription manager...
      subscriptionManager.setPluginManager(subscriptionPluginManager);

      notificationPluginManager.addFactory(new yancees.server.plugins.generic.
                                           GenericPluginFactory());
      notificationPluginManager.addFactory(new yancees.server.plugins.notification.push.
                                           PushPluginFactory());
      notificationPluginManager.addFactory(new yancees.server.plugins.notification.pull.
                                           PullPluginFactory());

      // Configure notification manager...
      notificationManager.setPluginManager(notificationPluginManager);

      */

      NotificationManagerTest test = new NotificationManagerTest();
      String[] pathList = {"/a/b/c","/a/b/d", "/", "/a", "/a/b/c/d"};
      System.out.println("Array");
      System.out.println(pathList);
      System.out.println("Each one's size");
      System.out.println(test.getPathDepth(pathList[0]));
      System.out.println(test.getPathDepth(pathList[1]));
      System.out.println(test.getPathDepth(pathList[2]));
      System.out.println(test.getPathDepth(pathList[3]));
      System.out.println(test.getPathDepth(pathList[4]));
      System.out.println("Max size");
      System.out.println(test.getMaxPathDepth(pathList));

   }


   /**
  * given a set of path names, separated by DOMNodeAdapter.CONTEXT_SEPARATOR,
  * we return the max path depth (the number of subcontexts in that path).
  *
  * @param paths a list of full path names to be compared.
  * @return
  */
 private int getMaxPathDepth(String[] paths) {
    int maxLen = 0;
    String currentPath;
    for (int i = 0; i < paths.length; i++) {
       currentPath = paths[i];
       maxLen = java.lang.Math.max(maxLen, getPathDepth(currentPath));
    }

    return maxLen;
 }

 /**
  * For example:
  * /a/b/c/d has depth = 4
  * / has depth = 0
  * /c has depth = 1
  *
  * @param path a full path name whose depth will be computed
  * @return the depth of the path
  */
 private int getPathDepth(String path) {
    int len = 0;
    for (int i = 0; i < path.length(); i++) {
       if (path.charAt(i) == DOMNodeAdapter.CONTEXT_SEPARATOR.charAt(0))
          len++;
    }

    // we want to differentiate '/' which is root, from '/something'
    // which is bigger.
    if (path.length() == 1) {
       len--;
    }

    return len;
 }


}